# HD app

HD app is the magic tool that allows the Happy Dev network to thrive in a decentralized way.

## Use cases

Identified and scheduled use cases of the application includes (but are not limited to):

- Listing of projects
- Listing of members
- Search of members by skills
- Invoicing and billing
- Project-scoped chat
- Personal messaging

### Chat

The repository of the SIB Chat component can be found here:

- https://git.happy-dev.fr/startinblox/sib-chat

It is based on XMPP as messaging protocol, Prosody as the server and ConverseJS as the client.

### Project

The repository of the project listing components is the core and can be found here:

- https://git.happy-dev.fr/startinblox/sib-core

### Invoicing

The invoicing component is still at an early stage. Its repository is here:

- https://git.happy-dev.fr/startinblox/sib-invoicing 

## Architecture

Some general schema of the existing StartinBlox applications architecture can be found here:

https://docs.google.com/presentation/d/1iCRGaJpFvZjhjIUnpsn6lRTJJ31ES6n94BNkJygzUwM/edit?usp=sharing

## Installation

If you want to contribute or test the app, please follow those steps.

### Requirements

You need to have both NodeJS and NPM installed and working.

### Installation process

clone then:

* `make install`

## Build

A first build is mandatory for compiling the static assets.

* `make build`

or

* `make watch`

if you are working on something and want to benefit of the hot reload feature.

## Run server

* `make serve`
